/* Made by Monkey Machine */

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.UnsupportedCallbackException;

/** The JAAS CallbackHandler for the client login. */
class CustomsecCallbackHandler implements CallbackHandler {
	private String _username;
	private char[] _password;

	public CustomsecCallbackHandler(String username, char[] password) {
		_username = username;
		_password = password;
	}

	public void handle(Callback[] callbacks) throws UnsupportedCallbackException {
		for (int i = 0; i < callbacks.length; i++) {
			Callback cb = callbacks[i];
			if (cb instanceof NameCallback) {
				((NameCallback)cb).setName(_username);
			}
			else if (cb instanceof PasswordCallback) {
				((PasswordCallback)cb).setPassword(_password);
			}
			else {
				throw new UnsupportedCallbackException(callbacks[i], "Unsupported Callback Type " + cb.getClass().getName());
			}
		}
	}
}
