/* Monkey Machine Ltd. */

package com.mkeym.customsec.ejb;

import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import java.rmi.RemoteException;
import javax.ejb.EJBException;
import javax.ejb.CreateException;
import java.sql.SQLException;
import javax.ejb.FinderException;
import javax.naming.InitialContext;
import javax.security.auth.Subject;

/**
 * @ejbHome <{com.mkeym.customsec.interfaces.TradingAccountHome}>
 * @ejbRemote <{com.mkeym.customsec.interfaces.TradingAccount}>
 * @ejbPrimaryKey <{String}>
 * @hasSimplePK
 */
public class TradingAccountBean implements EntityBean {
	private EntityContext ctx;

	/** @primaryKey */
	public String accountId;
	public int balance;

	public void setEntityContext(EntityContext context) {
		ctx = context;
	}

	public void unsetEntityContext() {
		ctx = null;
	}

	public void ejbActivate() {
	}

	public void ejbPassivate() {
	}

	public void ejbRemove() {
	}

	public void ejbStore() {
	}

	public void ejbLoad() {
	}

	public String ejbCreate(String accountId) {
		this.accountId = accountId;
		this.balance = 0;
		return null;
	}

	public void ejbPostCreate(String accountId) {
	}

	public String getAccountId() { return accountId; }

	public void setAccountId(String param) { this.accountId = param; }

	public void sell(String stock, int qty) {
		// ... perform the stock transaction here
		balance += qty * 100;
	}

	public void buy(String stock, int qty) {
		// ... perform the stock transaction here
		balance -= qty * 100;
	}

	public int getBalance() { return balance; }

	public void setBalance(int param) { this.balance = param; }
}
