package com.mkeym.customsec.web;

import java.io.IOException;
import java.util.Locale;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionServlet;
import org.apache.struts.util.MessageResources;

/** Implementation of <strong>Action</strong> that processes a generic application logoff. */
public final class LogoffAction extends Action {
	public ActionForward perform(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)
	    throws IOException, ServletException {
		    HttpSession session = request.getSession();
		    java.security.Principal p = request.getUserPrincipal();
		    if (p != null) {
			    // Process logoff for this Principal
			    String userName = p.getName();
			    if (servlet.getDebug() >= 1)
				    servlet.log("LogoffAction: User '" + userName + "' logged off in session " + session.getId());
		    }
		    else {
			    servlet.log("***** LogoffAction: Attempt to logoff with no Principal set!");
		    }
		    // remove the items stored in the session object
		    java.util.Enumeration e = session.getAttributeNames();
		    while (e.hasMoreElements()) {
			    String name = (String)e.nextElement();
			    session.removeAttribute(name);
		    }
		    // invalidate the session
		    session.invalidate();
		    return (mapping.findForward("success"));
	}
}
