/* Made by Monkey Machine */

package com.mkeym.customsec.web;

import com.mkeym.customsec.interfaces.*;
import java.io.IOException;
import javax.ejb.RemoveException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.util.MessageResources;
import java.util.*;

/** Implementation of <strong>Action</strong> which performs a trade */
public final class TradeAction extends CustomSecurityAction {
	/**  */
	public ActionForward perform(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)
	    throws IOException, ServletException {
		    String action = request.getParameter("action");
		    if (action == null)
			    action = "buy";
		    String accountId = request.getParameter("accountId");
		    String stockName = request.getParameter("stockName");
		    String qty = request.getParameter("quantity");
		    servlet.log("TradeAction: " + action + "ing " + qty + " " + stockName + " through account " + accountId);
		    try {
			    TradingAccountHome ah = getTradingAccountHome();
			    TradingAccount account = ah.findByPrimaryKey(accountId);
			    int quantity = Integer.parseInt(qty);
			    if ("buy".equals(action)) {
				    account.buy(stockName, quantity);
			    } else {
				    account.sell(stockName, quantity);
			    }
		    } catch (Exception e) {
			    throw new ServletException(e);
		    }
		    // Forward control to the success page
		    return (mapping.findForward("success"));
	}
}
